Page MenuHomePhabricator

Add red link experience to empty search results for wvui/mobile
Open, MediumPublic

Description

Description

When the precise search term was not found, desktop MediaWiki search results include a red link using which a new article can be created:

image.png (1×2 px, 966 KB)

Such a red link doesn't appear on the wvui or mobile search results (which will be eventually replaced by wvui). We should add one so that people can more easily create pages from mobile.

Note: there are two different search experiences on mobile: JS and non-JS. The non-JS experience is shared between desktop and mobile and as such any updates will need more consideration. It has its own task here: [will add link].

Designs

current desktopcurrent mobileproposed mobile
image.png (1×2 px, 966 KB)
image.png (1×724 px, 157 KB)
image.png (1×724 px, 173 KB)

When the precise search term was not found, desktop MediaWiki search results include a red link using which a new article can be created. Such a red link doesn't appear on the mobile search results. We should add one so that people can more easily create pages from mobile. There seem to be two cases to consider here (both sometimes have the additional "Did you mean" element present):

no page found, search term not found in other pagesno page found, search term found in other pages
en.wikipedia.org_w_index.php_search=Harmony+koreeeeee&title=Special%3ASearch&go=Go&ns0=1.png (737×1 px, 137 KB)
en.wikipedia.org_w_index.php_search=Elsie+Naomi&title=Special%3ASearch&profile=advanced&fulltext=1&advancedSearch-current=%7B%7D&ns0=1.png (688×1 px, 200 KB)

Developer notes

For mobile, this is blocked on T282473

This will require changes to the wvui Typeahead search using inheritance right now. While that code remains in that form this may work against our removal of technical debt so we may want to stall this until that happens.

Deprecated searchoverlay code

Showing the red link on https://en.m.wikipedia.org/w/index.php?search=Fooassa&title=Special%3ASearch&profile=default&fulltext=1&ns0=1
involves removing the CSS rule: .mw-search-createlink the red link drawer will then work

TODO

  • It should be possible to trigger red link creation from the wvui search widget
  • Remove the CSS hiding the red link creation links on the special:search page on mobile.

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

One of the constraints which I'm sorry for not pointing out before is the search page HTML is the same on mobile and desktop, so to change mobile we'd also need to change the desktop...

The changes in the left screenshot for this look sound:

image.png (1×1 px, 364 KB)

but can I suggest we pull the changes in the right screenshot into another separate task that also changes desktop?

alexhollender renamed this task from Search results on Mobile web don't include a red link to create a new article to Add redlink experience to empty search results on Mobile (JS version).Mar 29 2019, 4:59 PM
alexhollender updated the task description. (Show Details)

@Jdlrobson I've updated this task to scope it to the JS version only. The design is complete so I am moving it out of the design column. I will create the non-JS task now.

Jdlrobson lowered the priority of this task from Medium to Low.

@MMiller_WMF @ppelberg any interest in this task? I think it could be an important feature as it may serve as a bridge between reading and editing. Unfortunately our team hasn't been able to prioritize this.

@alexhollender -- thanks for pointing this out. This immediately makes me wonder how many pages get created via the redlink on desktop. More specifically, something like "what percent of new pages (that are not subsequently deleted) created by new editors on desktop are created via the search redlink?" I don't expect that we have the instrumentation to actually answer that question.

Anyway, we'll keep an eye on this task. One of my concerns (as others have brought up) is that our experience for creating totally new pages from mobile is not good -- maybe this would make more sense once we have more structured support for new page creation from mobile.

Not sure why @EncycloPetey thinks that having a create page option on mobile is "not helpful". I am a heavy mobile user and I create articles and new pages too. Just because no one does it, doesn't mean no one ever will. And that "no one" word doesn't even fit here. Search all edits using "New page", and "mobile edit" tags I am sure you will find many pages.

If we agree this is the right approach this is a straightforward task to fix and would be suitable for patch-welcome and Google-Code-in-2019 - let's check in at Humans of the Web whether this is something we want to do.

Have you considered to add a link to an help page that would provide best practices to create articles?

@Trizek-WMF I am pretty sure the content of that help page would vary per every wiki. A Mediawiki custom message (messages kept in the Mediawiki namespace in a wiki) might be a good way to approach this.

@Trizek-WMF I am pretty sure the content of that help page would vary per every wiki. A Mediawiki custom message (messages kept in the Mediawiki namespace in a wiki) might be a good way to approach this.

I'm not sure to understand. The content of the help page is indeed varying from one wiki to the other, but it is not a concern for the current design. Have a local override will never be as clean as a proper design. This is why I'm suggesting a proper design, created to handle the creation of a new article and the link to the help page.

We have enough links for help pages, see https://www.wikidata.org/wiki/Q10968373. It can fallback on https://meta.wikimedia.org/wiki/Help:Starting_a_new_page if no local page exists (yet).

@Trizek-WMF - just to make sure, you're suggesting both a link to create the article and a link to the help page right? I think this could be a good way to do this.

And to clarify are we talking about all new red links?
If so such a link could easily be added e.g. as an information icon/link to the existing red link drawer workflow:

Screenshot_20191105-071423_Chrome.jpg (2×1 px, 325 KB)

@Trizek-WMF - just to make sure, you're suggesting both a link to create the article and a link to the help page right?

Yes. And Jon's suggestion makes total sense (with a real "how to" link more than an icon). :)

And to clarify are we talking about all new red links?
If so such a link could easily be added e.g. as an information icon/link to the existing red link drawer workflow:

Screenshot_20191105-071423_Chrome.jpg (2×1 px, 325 KB)

@alexhollender - could you make a mock of this when you get a chance?

Have you considered to add a link to an help page that would provide best practices to create articles?

Were you imagining this link would appear near the "Create page" button (either in the empty search results screen, or in the drawer that appears when tapping a red link), or on the new page creation screen? I wonder if it would make more sense to offer it to people once they've decided to create a new page?

Have you considered to add a link to an help page that would provide best practices to create articles?

Were you imagining this link would appear near the "Create page" button (either in the empty search results screen, or in the drawer that appears when tapping a red link), or on the new page creation screen? I wonder if it would make more sense to offer it to people once they've decided to create a new page?

I think our best option would be to present it within the drawer, as @Jdlrobson suggested in T211006#5636346

Jdlrobson renamed this task from Add redlink experience to empty search results on Mobile (JS version) to Add red link experience to empty search results on Mobile (JS version).Mar 17 2020, 4:26 PM
Jdlrobson renamed this task from Add red link experience to empty search results on Mobile (JS version) to Add red link experience to empty search results on Minerva (JS version).
Jdlrobson edited projects, added MinervaNeue; removed MobileFrontend.
Jdlrobson added subscribers: Tacsipacsi, Ammarpad.
Jdlrobson raised the priority of this task from Low to Needs Triage.Mar 17 2020, 5:49 PM

Resetting priority given it was at one point high and I was the one that lowered it to low. It might be more important now in light of current events.

Change 580407 had a related patch set uploaded (by Jdlrobson; owner: Tacsipacsi):
[mediawiki/skins/MinervaNeue@master] Show red link at top of search results (non-JS version)

https://gerrit.wikimedia.org/r/580407

ovasileva triaged this task as Medium priority.EditedMar 18 2020, 2:36 PM

This seems risky to continue with right now. Let's discuss in standup. There's a few open questions here:

  • Overall risk
  • Effects to moderation
  • Do we want separate experiences for red links within articles and within search (and if so, should the former get it's own task)
  • Should we include help information as suggested by @Trizek-WMF and how?

@Tacsipacsi - We are currently slowing down our deployments over the next couple of weeks. As a result, we'll be pausing the work here for now. In the meantime, we would like answer some of the questions outlined above - in particular, we want to get an idea of the effects this change would have on moderation as well as solidify the designs. I will update this task once we have more info on this.

Notes from a quick chat @ovasileva and I had just now...
It seems like we, everyone who has commented on this ticket thus far, are in agreement there ought to be a workflow(s) for creating articles from search results that is well adapted to to mobile (device, context, etc.).

It also seems like there is good amount of uncertainty around who might engage with this workflow, why they might engage with this workflow, the impacts them engaging with this workflow could have on others [1] and as a result, how this workflow ought to be designed.

With this in mind, +1 to the root of the point @Trizek-WMF raised in T211006#5630616: "Have you considered to add a link to an help page that would provide best practices to create articles?"

IMO, it seems like a valuable first step would be to create and instrument just enough of the experience for us to be able to answer the following questions (not an exhaustive list) with more confidence than we are able to right now:

  • Who is attempting to create articles from search results on mobile?
  • Why are they engaging with the workflow for creating articles from search results on mobile? E.g. where on the spectrum of "I'm curious." <------> "I want to publish this new article right now." are they?
  • For people at varying points along this spectrum, what guidance/help do they need most in this moment to meet their needs/expectations?

  1. See @ovasileva's comments here: T211006#5979746
JTannerWMF added a subscriber: JTannerWMF.

It looks like the first step would be for the Web team, so I am moving this to the Editing Tracking tag.

Per T211006#5980933 please bump this back to backlog when we have a plan so we can work out what to do with @Tacsipacsi patch

This configuration setting is essential for wikis which over a half of the visitor are mobile users such as Korean Wikipedia. In addition, small wikis, which need to be more developed, have to give users more options or opportunities to create a new page. I think if it is optional and set to "false" by default, it will not cause a lot of problems.

Change 580407 abandoned by Jdlrobson:
[mediawiki/skins/MinervaNeue@master] Show red link at top of search results (non-JS version)

Reason:
Given https://phabricator.wikimedia.org/T211006#5979746 and https://phabricator.wikimedia.org/T211006#5021515 I recommend doing this in MediaWiki:Common.css as an interim state instead of doing this in Minerva.

https://gerrit.wikimedia.org/r/580407

Jdlrobson renamed this task from Add red link experience to empty search results on Minerva (JS version) to Add red link experience to empty search results on wvui (JS version).Jun 8 2021, 7:22 PM
Jdlrobson renamed this task from Add red link experience to empty search results on wvui (JS version) to Add red link experience to empty search results for wvui/mobile.
Jdlrobson edited projects, added WVUI; removed MinervaNeue.
Jdlrobson updated the task description. (Show Details)
Jdlrobson updated the task description. (Show Details)
LGoto added a subscriber: LGoto.

This task was closed as part of backlog upkeep. If you believe it was closed in error, please respond on the ticket.

Closed in error. Still a valid issue we want to address.